# javascript-problems-and-solutions

[![npm version](https://badge.fury.io/js/javascript-problems-and-solutions.svg)](https://badge.fury.io/js/javascript-problems-and-solutions)
[![Build Status](https://travis-ci.org/jeantimex/javascript-problems-and-solutions.svg?branch=master)](https://travis-ci.org/jeantimex/javascript-problems-and-solutions)
[![Coverage Status](https://coveralls.io/repos/github/jeantimex/javascript-problems-and-solutions/badge.svg?branch=code-coverage)](https://coveralls.io/github/jeantimex/javascript-problems-and-solutions?branch=code-coverage)
[![devDependencies Status](https://david-dm.org/jeantimex/javascript-problems-and-solutions/dev-status.svg)](https://david-dm.org/jeantimex/javascript-problems-and-solutions?type=dev)

A collection of JavaScript problems and solutions for studying algorithms.

![cover](https://user-images.githubusercontent.com/565300/33303581-c55a1280-d3b8-11e7-8e78-6879731416f1.png)

## Problems

### Tree

- [Add One Row to Tree](src/tree/add-one-row-to-tree.js)
- [Balanced Binary Tree](src/tree/balanced-binary-tree.js)
- [Binary Tree Inorder Traversal](src/tree/binary-tree-inorder-traversal.js)
- [Binary Tree Level Order Traversal](src/tree/binary-tree-level-order-traversal.js)
- [Binary Tree Longest Consecutive Sequence](src/tree/binary-tree-longest-consecutive-sequence.js)
- [Binary Tree Longest Consecutive Sequence II](src/tree/binary-tree-longest-consecutive-sequence-ii.js)
- [Binary Tree Maximum Path Sum](src/tree/binary-tree-maximum-path-sum.js)
- [Binary Tree Paths](src/tree/binary-tree-paths.js)
- [Binary Tree Postorder Traversal](src/tree/binary-tree-postorder-traversal.js)
- [Binary Tree Preorder Traversal](src/tree/binary-tree-preorder-traversal.js)
- [Binary Tree Upside Down](src/tree/binary-tree-upside-down.js)
- [Binary Tree Zigzag Level Order Traversal](src/tree/binary-tree-zigzag-level-order-traversal.js)
- [Closest Binary Search Tree Value](src/tree/closest-binary-search-tree-value.js)
- [Closest Binary Search Tree Value II](src/tree/closest-binary-search-tree-value-ii.js)
- [Construct Binary Tree From Preorder and Inorder Traversal](src/tree/construct-binary-tree-from-preorder-and-inorder-traversal.js)
- [Construct Binary Tree From Postorder and Inorder Traversal](src/tree/construct-binary-tree-from-inorder-and-postorder-traversal.js)
- [Convert BST to Greater Tree](src/tree/convert-bst-to-greater-tree.js)
- [Convert Sorted Array to Binary Search Tree](src/tree/convert-sorted-array-to-binary-search-tree.js)
- [Count Univalue Subtrees](src/tree/count-univalue-subtrees.js)
- [Delete Node in a BST](src/tree/delete-node-in-a-bst.js)
- [Diameter of Binary Tree](src/tree/diameter-of-binary-tree.js)
- [Find Bottom Left Tree Value](src/tree/find-bottom-left-tree-value.js)
- [Find Largest Value in Each Tree Row](src/tree/find-largest-value-in-each-tree-row.js)
- [Find Mode in Binary Search Tree](src/tree/find-mode-in-binary-search-tree.js)
- [Flatten Binary Tree to Linked List](src/tree/flatten-binary-tree-to-linked-list.js)
- [House Robber III](src/tree/house-robber-iii.js)
- [Inorder Predecessor in BST](src/tree/inorder-predecessor-in-bst.js)
- [Inorder Successor in BST](src/tree/inorder-successor-in-bst.js)
- [Kill Process](src/tree/kill-process.js)
- [Longest Univalue Path](src/tree/longest-univalue-path.js)
- [Lowest Common Ancestor of A Binary Search Tree](src/tree/lowest-common-ancestor-of-a-binary-search-tree.js)
- [Lowest Common Ancestor of a Binary Tree](src/tree/lowest-common-ancestor-of-a-binary-tree.js)
- [Maximum Binary Tree](src/tree/maximum-binary-tree.js)
- [Maximum Depth of Binary Tree](src/tree/maximum-depth-of-binary-tree.js)
- [Maximum Width of Binary Tree](src/tree/maximum-width-of-binary-tree.js)
- [Minimum Depth of Binary Tree](src/tree/minimum-depth-of-binary-tree.js)
- [Most Frequent Subtree Sum](src/tree/most-frequent-subtree-sum.js)
- [Path Sum](src/tree/path-sum.js)
- [Path Sum II](src/tree/path-sum-ii.js)
- [Path Sum III](src/tree/path-sum-iii.js)
- [Path Sum IV](src/tree/path-sum-iv.js)
- [Populating Next Right Pointers in Each Node](src/tree/populating-next-right-pointers-in-each-node.js)
- [Populating Next Right Pointers in Each Node II](src/tree/populating-next-right-pointers-in-each-node-ii.js)
- [Recover Binary Search Tree](src/tree/recover-binary-search-tree.js)
- [Same Tree](src/tree/same-tree.js)
- [Serialize and Deserialize BST](src/tree/serialize-and-deserialize-bst.js)
- [Serialize and Deserialize Binary Tree](src/tree/serialize-and-deserialize-binary-tree.js)
- [Subtree of Another Tree](src/tree/subtree-of-another-tree.js)
- [Sum Root to Leaf Numbers](src/tree/sum-root-to-leaf-numbers.js)
- [Symmetric Tree](src/tree/symmetric-tree.js)
- [Trim a Binary Search Tree](src/tree/trim-a-binary-search-tree.js)
- [Unique Binary Search Trees](src/tree/unique-binary-search-trees.js)
- [Unique Binary Search Trees II](src/tree/unique-binary-search-trees-ii.js)
- [Univalue Tree](src/tree/univalue-tree.js)
- [Validate Binary Search Tree](src/tree/validate-binary-search-tree.js)
- [Verify Preorder Sequence in Binary Search Tree](src/tree/verify-preorder-sequence-in-binary-search-tree.js)

### Graph

- [Clone Graph](src/graph/clone-graph.js)
- [Course Schedule](src/graph/course-schedule.js)
- [Course Schedule II](src/graph/course-schedule-ii.js)
- [Alien Dictionary](src/graph/alien-dictionary.js)
- [Graph Valid Tree](src/graph/graph-valid-tree.js)
- [Number of Connected Components in an Undirected Graph](src/graph/number-of-connected-components-in-an-undirected-graph.js)
- [Reconstruct Itinerary](src/graph/reconstruct-itinerary.js)
- [Evaluate Division](src/graph/evaluate-division.js)
- [Sequence Reconstruction](src/graph/sequence-reconstruction.js)
- [Minimum Height Trees](src/graph/minimum-height-trees.js)
- [Redundant Connection](src/graph/redundant-connection.js)
- [Redundant Connection II](src/graph/redundant-connection-ii.js)

### Trie (Prefix Tree)

- [Implement Trie (Prefix Tree)](src/common/trie.js)
- [Add and Search Word](src/trie/add-and-search-word-data-structure-design.js)
- [Word Search II](src/trie/word-search-ii.js)
- [Longest Word in Dictionary](src/trie/longest-word-in-dictionary.js)
- [Map Sum Pairs](src/trie/map-sum-pairs.js)
- [Implement Magic Dictionary](src/trie/implement-magic-dictionary.js)
- [Replace Words](src/trie/replace-words.js)
- [Top K Frequent Words](src/trie/top-k-frequent-words.js)
- [Concatenated Words](src/trie/concatenated-words.js)
- [Palindrome Pairs](src/trie/palindrome-pairs.js)
- [Design Search Autocomplete System](src/trie/design-search-autocomplete-system.js)
- [Word Squares](src/trie/word-squares.js)
- [Maximum XOR of Two Numbers in an Array](src/trie/maximum-xor-of-two-numbers-in-an-array.js)

### Backtracking

- [Subsets](src/backtracking/subsets.js)
- [Subsets II](src/backtracking/subsets-ii.js)
- [Combinations](src/backtracking/combinations.js)
- [Combination Sum](src/backtracking/combination-sum.js)

### Linked List

- [Add Two Numbers](src/linked-list/add-two-numbers.js)

### Dynamic Programming

- [Longest Increasing Subsequence](src/dynamic-programming/longest-increasing-subsequence.js)

## Author

I solve algorithm problems using JavaSript and Java, you can find all my LeetCode solutions and posts [here](https://discuss.leetcode.com/user/jeantimex).

## Support ##
<a href="https://paypal.me/jeantimex/3">
  <img alt="But Me a Coffee" src="https://az743702.vo.msecnd.net/cdn/kofi4.png?v=0" width="200" />
</a>

## LICENSE

MIT License

Copyright (c) 2017 Yong Su @jeantimex

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
